package com.biganto.visual.roompark.data.repository.db.requrey

import android.os.Parcel
import android.os.Parcelable

/**
 * Created by Vladislav Bogdashkin on 15.06.2018.
 */

private fun revisionStringToString(revisionString:String):String
{val ind  = revisionString.indexOf('?'); return if (ind>0) (revisionString.substring(0,ind)) else revisionString } //remove revision flag

private fun revisionStringToRevision(revisionString:String):String?
{val ind  = revisionString.indexOf('?'); return if (ind>0) (revisionString.substring(ind)) else null} //remove revision flag


class RevisionString(private val value:String, private val revision:String?){
    constructor(revisionString:String) : this(
            value= revisionStringToString(revisionString),revision= revisionStringToRevision(revisionString)
    )

    fun uri()=value

    /**
     * @return full-string with revision
     */
    fun revisionUri()="$value${revision.orEmpty()}"
}




class TitledPhoto(val title:String, val url:String){

    companion object{
        private const val delimiter = 'ø'
    }

    constructor(str:String) : this(
        title = str.substringBefore(delimiter),
        url = str.substringAfter(delimiter)
    )
}


//@Serializable
data class ResolutionRaw(
    val res_name:String,
    val url:String,
    val width:Int,
    val height:Int
) : Parcelable {
    constructor(parcel: Parcel) : this(
        parcel.readString(),
        parcel.readString(),
        parcel.readInt(),
        parcel.readInt()
    ) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(res_name)
        parcel.writeString(url)
        parcel.writeInt(width)
        parcel.writeInt(height)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<ResolutionRaw> {
        override fun createFromParcel(parcel: Parcel): ResolutionRaw {
            return ResolutionRaw(parcel)
        }

        override fun newArray(size: Int): Array<ResolutionRaw?> {
            return arrayOfNulls(size)
        }
    }
}