package com.biganto.visual.roompark.data.repository.db.requrey.utils;

import com.biganto.visual.roompark.data.repository.db.requrey.TitledPhoto;

import java.text.SimpleDateFormat;
import java.util.Locale;

import io.requery.Converter;
import timber.log.Timber;

/**
 * Created by Vladislav Bogdashkin on 04.07.2018.
 */


public class TitledPhotoConverter implements Converter<TitledPhoto, String> {

    private SimpleDateFormat apiFormat =new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS+hh:mm", Locale.ROOT);
    //SimpleDateFormat dbFormat =new SimpleDateFormat("YYYYMMDDThhmmss", Locale.ROOT);

    @SuppressWarnings("unchecked")
    @Override
    public Class<TitledPhoto> getMappedType() {
        return TitledPhoto.class;
    }

    @Override
    public Class<String> getPersistedType() {
        return String.class;
    }

    @Override
    public Integer getPersistedSize() {
        return null;
    }

    @Override
    public String convertToPersisted(TitledPhoto value) {
        return value == null ? null : apiFormat.format(value);
    }

    @Override
    public TitledPhoto convertToMapped(Class<? extends TitledPhoto> type,
                                String value) {

        try {
            return value == null ? null : new TitledPhoto(value);
        }
        catch (Exception e){
            Timber.e("Wrong stored data format! {%s}",value);
            return new TitledPhoto("","");
        }

    }
}